Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosol_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosol_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosol_mod.F90	(revision 4727)
@@ -173,14 +173,14 @@
 
 
-  SUBROUTINE init_aero_fromfile(flag_aerosol)
+SUBROUTINE init_aero_fromfile(flag_aerosol, aerosol_couple)
   USE netcdf
   USE mod_phys_lmdz_para
   USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
-#ifdef CPP_XIOS
-  USE xios
-#endif
+  USE lmdz_xios
   IMPLICIT NONE
+
   INTEGER, INTENT(IN) :: flag_aerosol
-#ifdef CPP_XIOS
+  LOGICAL, INTENT(IN) :: aerosol_couple
+  
   REAL,ALLOCATABLE :: lat_src(:)
   REAL,ALLOCATABLE :: lon_src(:)
@@ -191,55 +191,56 @@
   REAL :: null_array(0)
 
-  IF (flag_aerosol>0 .AND. grid_type==unstructured) THEN
+  IF (using_xios) THEN
+    IF (flag_aerosol>0 .AND. grid_type==unstructured .AND. (.NOT. aerosol_couple) ) THEN
   
-    IF (is_omp_root) THEN
+      IF (is_omp_root) THEN
   
-      IF (is_mpi_root) THEN
+        IF (is_mpi_root) THEN
     
-        IF (nf90_open(TRIM(file_aerosol), NF90_NOWRITE, ncid) /= NF90_NOERR) THEN
-          CALL check_err( nf90_open(TRIM(file_so4), NF90_NOWRITE, ncid), "pb open "//trim(file_so4) )
+          IF (nf90_open(TRIM(file_aerosol), NF90_NOWRITE, ncid) /= NF90_NOERR) THEN
+            CALL check_err( nf90_open(TRIM(file_so4), NF90_NOWRITE, ncid), "pb open "//trim(file_so4) )
+          ENDIF
+
+          ! Read and test longitudes
+          CALL check_err( nf90_inq_dimid(ncid, "lon", dimID),"pb inq dim lon") 
+          CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lon_src),"pb inq dim lon")
+          CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
+          ALLOCATE(lon_src(nbp_lon_src))
+          CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
+
+          ! Read and test latitudes
+          CALL check_err( nf90_inq_dimid(ncid, "lat", dimID),"pb inq dim lat") 
+          CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lat_src),"pb inq dim lat")
+          CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
+          ALLOCATE(lat_src(nbp_lat_src))
+          CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
+          IF (nf90_inq_dimid(ncid, 'lev', dimid) /= NF90_NOERR) THEN
+            IF (nf90_inq_dimid(ncid, 'presnivs', dimid)/= NF90_NOERR) THEN
+               CALL check_err(nf90_inq_dimid(ncid, 'PRESNIVS', dimid),'dimension lev,PRESNIVS or presnivs not in file')
+            ENDIF
+          ENDIF
+          CALL check_err( nf90_inquire_dimension(ncid, dimid, len = klev_src),"pb inq dim for PRESNIVS or lev" )
+          CALL check_err( nf90_close(ncid),"pb in close" )   
         ENDIF
 
-        ! Read and test longitudes
-        CALL check_err( nf90_inq_dimid(ncid, "lon", dimID),"pb inq dim lon") 
-        CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lon_src),"pb inq dim lon")
-        CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
-        ALLOCATE(lon_src(nbp_lon_src))
-        CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
-
-        ! Read and test latitudes
-        CALL check_err( nf90_inq_dimid(ncid, "lat", dimID),"pb inq dim lat") 
-        CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lat_src),"pb inq dim lat")
-        CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
-        ALLOCATE(lat_src(nbp_lat_src))
-        CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
-        IF (nf90_inq_dimid(ncid, 'lev', dimid) /= NF90_NOERR) THEN
-          IF (nf90_inq_dimid(ncid, 'presnivs', dimid)/= NF90_NOERR) THEN
-             CALL check_err(nf90_inq_dimid(ncid, 'PRESNIVS', dimid),'dimension lev,PRESNIVS or presnivs not in file')
-          ENDIF
+        CALL bcast_mpi(nbp_lat_src)
+        CALL bcast_mpi(nbp_lon_src)
+        CALL bcast_mpi(klev_src)
+
+        IF (is_mpi_root ) THEN
+          CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=nbp_lat_src, jbegin=0, latvalue_1d=lat_src)
+          CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=nbp_lon_src, ibegin=0, lonvalue_1d=lon_src)
+        ELSE
+          CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=0, jbegin=0, latvalue_1d=null_array )
+          CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=0, ibegin=0, lonvalue_1d=null_array)
         ENDIF
-        CALL check_err( nf90_inquire_dimension(ncid, dimid, len = klev_src),"pb inq dim for PRESNIVS or lev" )
-        CALL check_err( nf90_close(ncid),"pb in close" )   
+        CALL xios_set_axis_attr("axis_aerosol",n_glo=klev_src)
+        CALL xios_set_fieldgroup_attr("aerosols", enabled=.TRUE.)
+  
       ENDIF
-
-      CALL bcast_mpi(nbp_lat_src)
-      CALL bcast_mpi(nbp_lon_src)
-      CALL bcast_mpi(klev_src)
-
-      IF (is_mpi_root ) THEN
-        CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=nbp_lat_src, jbegin=0, latvalue_1d=lat_src)
-        CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=nbp_lon_src, ibegin=0, lonvalue_1d=lon_src)
-      ELSE
-        CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=0, jbegin=0, latvalue_1d=null_array )
-        CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=0, ibegin=0, lonvalue_1d=null_array)
-      ENDIF
-      CALL xios_set_axis_attr("axis_aerosol",n_glo=klev_src)
-      CALL xios_set_fieldgroup_attr("aerosols", enabled=.TRUE.)
-  
-    ENDIF
     
-  ENDIF    
-#endif 
-  END SUBROUTINE init_aero_fromfile
+    ENDIF    
+  ENDIF !using_xios 
+END SUBROUTINE init_aero_fromfile
 
 
@@ -271,7 +272,5 @@
     USE iophy, ONLY : io_lon, io_lat
     USE print_control_mod, ONLY: lunout
-#ifdef CPP_XIOS
-    USE xios
-#endif
+    USE lmdz_xios
     IMPLICIT NONE
       
@@ -685,5 +684,4 @@
 
     IF (grid_type==unstructured) THEN
-#ifdef CPP_XIOS
       IF (is_omp_master) THEN
         CALL xios_send_field(TRIM(varname)//"_in",varyear)
@@ -702,5 +700,4 @@
       CALL scatter_omp(psurf_interp,psurf_out)
       first=.FALSE.
-#endif
     ELSE
       ! Scatter global field to local domain at local process
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosolstrato.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosolstrato.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosolstrato.F90	(revision 4727)
@@ -16,7 +16,5 @@
     USE dimphy
     USE print_control_mod, ONLY: prt_level,lunout
-#ifdef CPP_XIOS
-    USE xios
-#endif
+    USE lmdz_xios
     implicit none
 
@@ -148,5 +146,4 @@
 
     IF (grid_type==unstructured) THEN
-#ifdef CPP_XIOS
       IF (is_omp_master) THEN
         CALL xios_send_field("taustrat_in",tauaerstrat_mois)
@@ -157,5 +154,4 @@
       ENDIF
       CALL scatter_omp(tau_aer_strat_mpi,tau_aer_strat)
-#endif
     ELSE  
 !--scatter on all proc
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosolstrato_m.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosolstrato_m.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/readaerosolstrato_m.F90	(revision 4727)
@@ -23,11 +23,10 @@
 
 
-  SUBROUTINE init_readaerosolstrato1
-#ifdef CPP_XIOS
+SUBROUTINE init_readaerosolstrato1
   USE netcdf
   USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
                       nf95_inq_varid, nf95_open
   USE mod_phys_lmdz_para
-  USE xios
+  USE lmdz_xios
 !  USE YOERAD, ONLY : NLW
   IMPLICIT NONE
@@ -38,4 +37,5 @@
   INTEGER :: ncid_in, varid
   
+  IF (using_xios) THEN
     IF (is_omp_master) THEN  
       IF (is_mpi_root) THEN
@@ -63,14 +63,13 @@
     ENDIF
     
-#endif
-  END SUBROUTINE init_readaerosolstrato1
+  ENDIF
+END SUBROUTINE init_readaerosolstrato1
   
-  SUBROUTINE init_readaerosolstrato2
-#ifdef CPP_XIOS
+SUBROUTINE init_readaerosolstrato2
   USE netcdf
   USE netcdf95, ONLY: nf95_close, nf95_gw_var, nf95_inq_dimid, & 
                       nf95_inq_varid, nf95_open
   USE mod_phys_lmdz_para
-  USE xios
+  USE lmdz_xios
 !  USE YOERAD, ONLY : NLW
   IMPLICIT NONE
@@ -80,5 +79,6 @@
   REAL    :: null_array(0)
   INTEGER :: ncid_in, varid
-
+  
+  IF (using_xios) THEN
     IF (is_omp_master) THEN    
       IF (is_mpi_root) THEN
@@ -131,6 +131,6 @@
 
     ENDIF
-#endif    
-  END SUBROUTINE init_readaerosolstrato2
+  ENDIF    
+END SUBROUTINE init_readaerosolstrato2
   
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/regr_horiz_time_climoz_m.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/regr_horiz_time_climoz_m.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/regr_horiz_time_climoz_m.F90	(revision 4727)
@@ -66,7 +66,5 @@
   USE regular_lonlat_mod, ONLY: boundslon_reg, boundslat_reg, south, west, east
   USE slopes_m,           ONLY: slopes
-#ifdef CPP_XIOS
-  USE xios
-#endif
+  USE lmdz_xios
   USE mod_phys_lmdz_para, ONLY: is_mpi_root, is_master, is_omp_master, gather, gather_mpi, bcast_mpi, klon_mpi
   USE geometry_mod, ONLY : latitude_deg, ind_cell_glo
@@ -240,5 +238,4 @@
       CALL bcast_mpi(ntim_ou)
 
-#ifdef CPP_XIOS    
       IF (is_mpi_root) THEN
         CALL xios_set_domain_attr("domain_climoz",nj_glo=nlat_in, nj=nlat_in, jbegin=0, latvalue_1d=lat_in/deg2rad)
@@ -262,5 +259,4 @@
       CALL  xios_set_field_attr("tro3_out", enabled=.TRUE.)
       CALL  xios_set_field_attr("tro3_out", enabled=.TRUE.)
-#endif
       
       IF (first) THEN
@@ -415,5 +411,4 @@
     !=============================================================================
      IF (grid_type==unstructured) THEN
-#ifdef CPP_XIOS
        nlat_ou=klon_mpi
        
@@ -428,5 +423,4 @@
        CALL xios_send_field("tro3_in",o3_in3bis(:,:,:,:,:))
        CALL xios_recv_field("tro3_out",o3_regr_lonlat(1,:,:,:,:))
-#endif
      ELSE
           
@@ -462,10 +456,8 @@
      nlat_ou=nbp_lat
      IF (grid_type==unstructured) THEN
-#ifdef CPP_XIOS
        CALL xios_send_field('o3_out',o3_out3)
        ndims=3 
        ALLOCATE(o3_out3_glo(nlat_ou, nlev_in, ntim_ou, read_climoz))
        CALL gather_mpi(o3_out3(1,:,:,:,:), o3_out3_glo)
-#endif
      ENDIF
 
@@ -508,5 +500,4 @@
    
      IF (grid_type==unstructured) THEN
-#ifdef CPP_XIOS
        nlat_ou=klon_mpi
 
@@ -522,5 +513,4 @@
        IF(.NOT.lprev) o3_regr_lat(:,:, 0, :) = o3_regr_lat(:,:,12,:)
        IF(.NOT.lnext) o3_regr_lat(:,:,13, :) = o3_regr_lat(:,:, 1,:)
-#endif       
      
      ELSE 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/rrtm/readaerosolstrato1_rrtm.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/rrtm/readaerosolstrato1_rrtm.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/rrtm/readaerosolstrato1_rrtm.F90	(revision 4727)
@@ -18,7 +18,5 @@
     USE YOERAD, ONLY : NLW
     USE YOMCST
-#ifdef CPP_XIOS
-    USE xios
-#endif
+    USE lmdz_xios
 
     IMPLICIT NONE
@@ -167,5 +165,4 @@
     
     IF (grid_type==unstructured) THEN
-#ifdef CPP_XIOS
       IF (is_omp_master) THEN
         ALLOCATE(tauaerstrat_mpi(klon_mpi,klev))
@@ -176,5 +173,4 @@
       ENDIF
       CALL scatter_omp(tauaerstrat_mpi,tau_aer_strat)
-#endif
     ELSE  
       CALL scatter(tauaerstrat_mois_glo,tau_aer_strat)
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/rrtm/readaerosolstrato2_rrtm.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/rrtm/readaerosolstrato2_rrtm.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/rrtm/readaerosolstrato2_rrtm.F90	(revision 4727)
@@ -19,7 +19,5 @@
     USE YOERAD, ONLY : NLW
     USE YOMCST
-#ifdef CPP_XIOS
-    USE xios
-#endif
+    USE lmdz_xios
 
     IMPLICIT NONE
@@ -282,6 +280,4 @@
 
       IF (grid_type==unstructured) THEN
-
-#ifdef CPP_XIOS
 
         IF (is_omp_master) THEN
@@ -310,5 +306,4 @@
         CALL scatter_omp(cgaerstrat_mpi,cg_aer_strat)
         CALL scatter_omp(taulwaerstrat_mpi,taulw_aer_strat)
-#endif
       ELSE  
         
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/screenc_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/screenc_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/screenc_mod.F90	(revision 4727)
@@ -18,5 +18,5 @@
                          ts, qsurf, z0m, z0h, psol, &
                          ustar, testar, qstar, okri, ri1, &
-                         pref, delu, delte, delq)
+                         pref, delu, delte, delq, s_pblh, prain, tsol, pat1)
       IMPLICIT NONE
 !-----------------------------------------------------------------------
@@ -60,6 +60,13 @@
       REAL, dimension(klon), intent(in) :: speed, temp, q_zref
       REAL, intent(in) :: zref
-      REAL, dimension(klon), intent(in) :: ts, qsurf, z0m, z0h, psol
-      REAL, dimension(klon), intent(in) :: ustar, testar, qstar, ri1         
+      REAL, dimension(klon), intent(IN) :: ts
+      REAL, dimension(klon), intent(in) :: qsurf, psol
+      REAL, dimension(klon), intent(inout):: z0m, z0h
+      REAL, dimension(klon), intent(in) :: ustar, testar, qstar, ri1   
+
+      REAL, dimension(klon), intent(inout) :: s_pblh    
+      REAL, dimension(klon), intent(in) :: prain    
+      REAL, dimension(klon), intent(in) :: tsol    
+      REAL, DIMENSION(klon), INTENT(IN)    :: pat1 !pression premier lev      
 !
       REAL, dimension(klon), intent(out) :: pref, delu, delte, delq 
@@ -88,7 +95,7 @@
       CALL cdrag (knon, nsrf, &
                     speed, temp, q_zref, gref, &
-                    psol, ts, qsurf, z0m, z0h, &
+                    psol, s_pblh, ts, qsurf, z0m, z0h, &
                     zri_zero,0,                &
-                    cdram, cdrah, zri1, pref)
+                    cdram, cdrah, zri1, pref, prain, tsol, pat1)
       DO i = 1, knon
         IF(ok_prescr_ust) THEN
@@ -114,5 +121,5 @@
                          cdrm, cdrh,  okri, &
                          ri1, iri1, &
-                         pref, delm, delh, zri1)
+                         pref, delm, delh, zri1, s_pblh, prain, tsol, pat1)
       IMPLICIT NONE
 !-----------------------------------------------------------------------
@@ -156,6 +163,11 @@
       REAL, dimension(klon), intent(in) :: speed, temp, q_zref
       REAL, intent(in) :: zref
-      REAL, dimension(klon), intent(in) :: ts, qsurf, z0m, z0h, psol
+      REAL, dimension(klon), intent(in) :: ts, qsurf, psol
+      REAL, dimension(klon), intent(inout) :: z0m, z0h
       REAL, dimension(klon), intent(in) :: cdrm, cdrh, ri1         
+      REAL, dimension(klon), intent(inout) :: s_pblh    
+      REAL, dimension(klon), intent(in) :: prain    
+      REAL, dimension(klon), intent(in) :: tsol    
+      REAL, DIMENSION(klon), INTENT(IN) :: pat1 !pression premier lev      
       INTEGER, INTENT(IN)  :: iri1 ! Richardson de la 1ere couche
 !
@@ -180,7 +192,7 @@
       CALL cdrag(knon, nsrf, &
                     speed, temp, q_zref, gref, &
-                    psol, ts, qsurf, z0m, z0h, &
+                    psol, s_pblh, ts, qsurf, z0m, z0h, &
                     ri1, iri1, &
-                    cdram, cdrah, zri1, pref)
+                    cdram, cdrah, zri1, pref, prain, tsol, pat1)
       DO i = 1, knon
         delm(i) = sqrt(cdrm(i))/sqrt(cdram(i))
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/stdlevvar_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/stdlevvar_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/stdlevvar_mod.F90	(revision 4727)
@@ -19,5 +19,5 @@
                            u1, v1, t1, q1, z1, &
                            ts1, qsurf, z0m, z0h, psol, pat1, &
-                           t_2m, q_2m, t_10m, q_10m, u_10m, ustar)
+                           t_2m, q_2m, t_10m, q_10m, u_10m, ustar, s_pblh, prain, tsol)
       IMPLICIT NONE
 !-------------------------------------------------------------------------
@@ -61,9 +61,13 @@
       LOGICAL, intent(in) :: zxli
       REAL, dimension(klon), intent(in) :: u1, v1, t1, q1, z1, ts1
-      REAL, dimension(klon), intent(in) :: qsurf, z0m, z0h
+      REAL, dimension(klon), intent(in) :: qsurf
+      REAL, dimension(klon), intent(inout) :: z0m, z0h
       REAL, dimension(klon), intent(in) :: psol, pat1
 !
       REAL, dimension(klon), intent(out) :: t_2m, q_2m, ustar
       REAL, dimension(klon), intent(out) :: u_10m, t_10m, q_10m
+      REAL, DIMENSION(klon), INTENT(INOUT) :: s_pblh
+      REAL, DIMENSION(klon), INTENT(IN) :: prain
+      REAL, DIMENSION(klon), INTENT(IN) :: tsol
 !-------------------------------------------------------------------------
       include "flux_arp.h"
@@ -120,7 +124,7 @@
       CALL cdrag(knon, nsrf, &
  &                   speed, t1, q1, z1, &
- &                   psol, ts1, qsurf, z0m, z0h, &
+ &                   psol, s_pblh, ts1, qsurf, z0m, z0h, &
  &                   zri_zero, 0, &
- &                   cdram, cdrah, zri1, pref)
+ &                   cdram, cdrah, zri1, pref, prain, tsol, pat1)
 
 ! --- special Dice: on force cdragm ( a defaut de forcer ustar) MPL 05082013
@@ -178,5 +182,5 @@
  &                   ts1, qsurf, z0m, z0h, psol, &           
  &                   ustar, testar, qstar, okri, ri1, &
- &                   pref, delu, delte, delq) 
+ &                   pref, delu, delte, delq, s_pblh ,prain, tsol, pat1) 
 !
         DO i = 1, knon
@@ -280,5 +284,5 @@
  &                   ts1, qsurf, z0m, z0h, psol, &
  &                   ustar, testar, qstar, okri, ri1, &
- &                   pref, delu, delte, delq)
+ &                   pref, delu, delte, delq, s_pblh ,prain, tsol, pat1)
 !
         DO i = 1, knon
@@ -357,6 +361,7 @@
       INTEGER, intent(in) :: klon, knon, nsrf
       LOGICAL, intent(in) :: zxli
-      REAL, dimension(klon), intent(in) :: u1, v1, t1, q1, z1, ts1
-      REAL, dimension(klon), intent(in) :: qsurf, z0m, z0h
+      REAL, dimension(klon), intent(in) :: u1, v1, t1, q1, ts1, z1
+      REAL, dimension(klon), intent(inout) :: z0m, z0h
+      REAL, dimension(klon), intent(in) :: qsurf
       REAL, dimension(klon), intent(in) :: psol, pat1
 !
@@ -371,4 +376,7 @@
       REAL, dimension(klon) :: cdmn2m, cdhn2m, fm2m, fh2m
       REAL, dimension(klon) :: ri2m_new
+      REAL, DIMENSION(klon) :: s_pblh
+      REAL, DIMENSION(klon) :: prain
+      REAL, DIMENSION(klon) :: tsol
 !-------------------------------------------------------------------------
       include "flux_arp.h"
@@ -444,7 +452,7 @@
       CALL cdrag(knon, nsrf, &
  &                   speed, t1, q1, z1, &
- &                   psol, ts1, qsurf, z0m, z0h, &
+ &                   psol, s_pblh, ts1, qsurf, z0m, z0h, &
  &                   zri_zero, 0, &
- &                   cdram, cdrah, zri1, pref)
+ &                   cdram, cdrah, zri1, pref, prain, tsol, pat1)
 
 !
@@ -468,5 +476,6 @@
  &                   cdram, cdrah,  okri, &
  &                   ri1, 1, &
- &                   pref_new, delm_new, delh_new, ri2m)
+ &                   pref_new, delm_new, delh_new, ri2m, &
+ &                   s_pblh, prain, tsol, pat1      )
 !
        DO i = 1, knon
@@ -535,5 +544,6 @@
  &                   cdram, cdrah,  okri, &
  &                   ri1, 0, &
- &                   pref, delm, delh, ri2m)
+ &                   pref, delm, delh, ri2m, &
+ &                   s_pblh, prain, tsol, pat1      )
 !
         DO i = 1, knon
@@ -614,5 +624,6 @@
  &                   cdram, cdrah,  okri, &
  &                   ri1, 1, &
- &                   pref_new, delm_new, delh_new, ri10m)
+ &                   pref_new, delm_new, delh_new, ri10m, &
+ &                   s_pblh, prain, tsol, pat1      )
 !
        DO i = 1, knon
@@ -671,5 +682,6 @@
  &                   cdram, cdrah,  okri, &
  &                   ri1, 0, &
- &                   pref, delm, delh, ri10m)
+ &                   pref, delm, delh, ri10m, &
+ &                   s_pblh, prain, tsol, pat1      )
 !
         DO i = 1, knon
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_mod.F90	(revision 4727)
@@ -11,5 +11,5 @@
        rlon, rlat, yrmu0, &
        debut, lafin, zlev, ccanopy, swnet, lwnet, albedo, &
-       tsurf, p1lay, cdragh, cdragm, precip_rain, precip_snow, temp_air, spechum, &
+       tsurf, p1lay, cdragh, cdragm, precip_rain, precip_snow, precip_bs, temp_air, spechum, &
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, & 
@@ -17,5 +17,5 @@
        lwdown_m, q2m, t2m, &
        snow, qsol, agesno, tsoil, &
-       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &   
+       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, fluxbs, &   
        qsurf, tsurf_new, dflux_s, dflux_l, &
        flux_u1, flux_v1 , & 
@@ -81,5 +81,5 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: p1lay
     REAL, DIMENSION(klon), INTENT(IN)       :: cdragh, cdragm
-    REAL, DIMENSION(klon), INTENT(IN)       :: precip_rain, precip_snow
+    REAL, DIMENSION(klon), INTENT(IN)       :: precip_rain, precip_snow, precip_bs
     REAL, DIMENSION(klon), INTENT(IN)       :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)       :: AcoefH, AcoefQ, BcoefH, BcoefQ
@@ -109,5 +109,5 @@
 !albedo SB <<<
     REAL, DIMENSION(klon), INTENT(OUT)       :: evap
-    REAL, DIMENSION(klon), INTENT(OUT)       :: fluxsens, fluxlat
+    REAL, DIMENSION(klon), INTENT(OUT)       :: fluxsens, fluxlat, fluxbs
     REAL, DIMENSION(klon), INTENT(OUT)       :: qsurf
     REAL, DIMENSION(klon), INTENT(OUT)       :: tsurf_new
@@ -125,4 +125,5 @@
     REAL, DIMENSION(klon) :: tsol_rad, emis_new ! output from interfsol not used
     REAL, DIMENSION(klon) :: u0, v0     ! surface speed
+    REAL, DIMENSION(klon) :: precip_totsnow     ! total solid precip
     INTEGER               :: i
 
@@ -130,4 +131,16 @@
     REAL, DIMENSION(klon)      :: alb1_new,alb2_new
 !albedo SB <<<
+
+
+!****************************************************************************************
+!Total solid precip
+
+IF (ok_bs) THEN
+precip_totsnow(:)=precip_snow(:)+precip_bs(:)
+ELSE
+precip_totsnow(:)=precip_snow(:)
+ENDIF
+!****************************************************************************************
+
 
 !**************************************************************************************** 
@@ -165,7 +178,7 @@
             zlev,  u1, v1, gustiness, temp_air, spechum, epot_air, ccanopy, & 
             cdragh, AcoefH, AcoefQ, BcoefH, BcoefQ, &
-            precip_rain, precip_snow, lwdown_m, swnet, swdown, &
+            precip_rain, precip_totsnow, lwdown_m, swnet, swdown, &
             pref_tmp, q2m, t2m, &
-            evap, fluxsens, fluxlat, &              
+            evap, fluxsens, fluxlat,  &              
             tsol_rad, tsurf_new, alb1_new, alb2_new, &
             emis_new, z0m, z0h, qsurf, &
@@ -184,5 +197,5 @@
 !****************************************************************************************
        CALL surf_land_bucket(itime, jour, knon, knindex, debut, dtime,&
-            tsurf, p1lay, cdragh, precip_rain, precip_snow, temp_air, &
+            tsurf, p1lay, cdragh, precip_rain, precip_totsnow, temp_air, &
             spechum, AcoefH, AcoefQ, BcoefH, BcoefQ, pref, &
             u1, v1, gustiness, rugoro, swnet, lwnet, &
@@ -192,5 +205,10 @@
         z0h(1:knon)=z0m(1:knon) ! En attendant mieux
 
+
     ENDIF ! ok_veget
+
+        ! blowing snow not treated yet over land
+        fluxbs(:)=0.
+
 
 !****************************************************************************************
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_mod.F90	(revision 4727)
@@ -632,5 +632,5 @@
     fluxsens(1:knon) = -1. * fluxsens(1:knon)
     fluxlat(1:knon)  = -1. * fluxlat(1:knon)
-    
+   
 !  evap     = -1. * evap
 
@@ -701,9 +701,6 @@
   SUBROUTINE Get_orchidee_communicator(orch_comm, orch_mpi_size, orch_mpi_rank, orch_omp_size,orch_omp_rank)
   USE  mod_surf_para
+  USE lmdz_mpi
       
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
     INTEGER,INTENT(OUT) :: orch_comm
     INTEGER,INTENT(OUT) :: orch_mpi_size
@@ -725,9 +722,7 @@
       ENDIF
     
-#ifdef CPP_MPI    
       CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
       CALL MPI_COMM_SIZE(orch_comm,orch_mpi_size,ierr)
       CALL MPI_COMM_RANK(orch_comm,orch_mpi_rank,ierr)
-#endif
     
     ENDIF
@@ -753,8 +748,5 @@
     USE mod_surf_para    
     USE indice_sol_mod
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
+    USE lmdz_mpi
 
 ! Input arguments
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nofrein_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nofrein_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nofrein_mod.F90	(revision 4727)
@@ -527,9 +527,6 @@
   SUBROUTINE Get_orchidee_communicator(orch_comm,orch_omp_size,orch_omp_rank)
   USE  mod_surf_para
+  USE lmdz_mpi
       
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
     INTEGER,INTENT(OUT) :: orch_comm
     INTEGER,INTENT(OUT) :: orch_omp_size
@@ -550,7 +547,5 @@
       ENDIF
     
-#ifdef CPP_MPI    
       CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
-#endif
     
     ENDIF
@@ -577,8 +572,5 @@
     USE mod_surf_para    
     USE indice_sol_mod
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
+    USE lmdz_mpi
 
 ! Input arguments
Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nolic_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nolic_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/surf_land_orchidee_nolic_mod.F90	(revision 4727)
@@ -689,10 +689,7 @@
 
   SUBROUTINE Get_orchidee_communicator(orch_comm, orch_mpi_size, orch_mpi_rank, orch_omp_size,orch_omp_rank)
+  USE lmdz_mpi
   USE  mod_surf_para
       
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
-
     INTEGER,INTENT(OUT) :: orch_comm
     INTEGER,INTENT(OUT) :: orch_mpi_size
@@ -714,9 +711,7 @@
       ENDIF
     
-#ifdef CPP_MPI    
       CALL MPI_COMM_SPLIT(COMM_LMDZ_PHY,color,mpi_rank,orch_comm,ierr)
       CALL MPI_COMM_SIZE(orch_comm,orch_mpi_size,ierr)
       CALL MPI_COMM_RANK(orch_comm,orch_mpi_rank,ierr)
-#endif
     
     ENDIF
@@ -742,8 +737,5 @@
     USE mod_surf_para    
     USE indice_sol_mod
-
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif    
+    USE lmdz_mpi
 
 ! Input arguments
